﻿using System;
using System.IO;
using Firma;
using System.Xml;
using System.Text;
using System.Xml.Serialization;


using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;



namespace firmarFEL
{
    class Program
    {        
        static void Main(string[] args)
        {

            string version = "2019-01-30";

            if(args[0]=="version")
            {
                Console.WriteLine(version);                
            }
            else
            { 

               StreamReader objReader = new StreamReader(args[0]);
            
                string certificarXML = "";
                string rutaGuardar = "";
                string archivoFirma = "";
                string clave = "";
                string TAG = "";
                string destinoErrores = "";

                string error = "";

                try
               {
                   archivoFirma = objReader.ReadLine();
                   clave = objReader.ReadLine();
                   certificarXML = objReader.ReadLine();
                   rutaGuardar = objReader.ReadLine();
                   TAG = objReader.ReadLine();
                   destinoErrores = objReader.ReadLine();
               }
               finally
               {

               }
           
               objReader.Close();

               File.Delete(destinoErrores);



                try
                {
                    // Prueba 1
                    //XmlDocument xml = new XmlDocument();
                    //Encoding utf8WithoutBom = new UTF8Encoding(true);
                    //xml.Load(certificarXML);
                    //using (TextWriter sw = new StreamWriter(certificarXML, false, utf8WithoutBom))
                    //{ xml.Save(sw); }

                    // prueba 2
                    //Serealiza la clase plantilla a XML-utf8
                    //var serializer = new XmlSerializer(typeof(List<documento>));
                    //var memoryStream = new MemoryStream();
                    //var streamWriter = new StreamWriter(memoryStream, System.Text.Encoding.UTF8);
                    //serializer.Serialize(streamWriter, lote);
                    //memoryStream.Seek(0, SeekOrigin.Begin);
                    //var streamReader = new StreamReader(memoryStream, System.Text.Encoding.UTF8);
                    //var utf8EncodedXml = streamReader.ReadToEnd();
                    //DateTime fecha = DateTime.Now;
                    //string nameFile = PathOutJPG + @"\LoteJPG" + fecha.ToString("ddmmyyyyhhmmss") + ".xml";
                    //File.WriteAllText(nameFile, utf8EncodedXml.ToString());


                    // prueba 3

                    //var serializer = new XmlSerializer(typeof(MyObject));
                    //var writer = new StringWriter();
                    //serializer.Serialize(writer, myObject);
                    //var xml = writer.ToString();

                    Console.WriteLine("Firmando...");
                    FirmaDocumento.FirmarDocumento(archivoFirma, clave, certificarXML, rutaGuardar, TAG);
                }
                catch (Exception es)
                {
                     error = "Error en la firma del documento, error reportado: " + es.Message;
                }

                if (error != "")
                {                
                     System.IO.File.WriteAllText(destinoErrores, error);
                }
                
            }

        }
    }
}
